#ifndef PIXMAP_ITEM_H
#define PIXMAP_ITEM_H

#include <QGraphicsPixmapItem>
#include <elements.h>

class PixmapItem: public EdgeItem, public QGraphicsPixmapItem
{
public:
	PixmapItem( NodeItem*, NodeItem* );
	PixmapItem( QDomElement el);
	virtual void setFromPoint( int x0, int y0 ) ;
	virtual void setToPoint( int x0, int y0 );
	virtual void setTabs( QTabWidget *properties);
	virtual void setFlag ( QGraphicsItem::GraphicsItemFlag flag, bool enabled = true ) {QGraphicsPixmapItem::setFlag(flag, enabled);};
	virtual void paintItem(int x0, int y0,QPainter *pp, qreal scale);
	virtual QDomElement toXml(QDomDocument doc);
	QString filename;
	QPixmap *orig_image;
	QPixmap *scale_image;
	int maxx, maxy;
	int xx, yy;
protected:
	QVariant itemChange(GraphicsItemChange change, const QVariant &value);
};

#endif
