#ifndef TEXT_ITEM_H
#define TEXT_ITEM_H

#include <QGraphicsTextItem>
#include <elements.h>


class TextItem: public EdgeItem, public QGraphicsSimpleTextItem
{
public:
	TextItem( NodeItem*, NodeItem* );
	TextItem( QDomElement el);
	virtual void setFromPoint( int x, int y ) ;
	virtual void setToPoint( int x, int y );
	virtual void setTabs( QTabWidget *properties);
	virtual void setPen ( const QPen & pen ) {EdgeItem::setPen(pen);QGraphicsSimpleTextItem::setPen(pen);};
	virtual void setFlag ( QGraphicsItem::GraphicsItemFlag flag, bool enabled = true ) {QGraphicsSimpleTextItem::setFlag(flag, enabled);};
	virtual void paint(QPainter *painter, const QStyleOptionGraphicsItem *option, QWidget *widget);
	QRectF boundingRect() const { return QRectF(0, 0, ww, hh); }
	bool contains(const QPointF &point) const {return QRectF(0,0, ww, hh).contains(point); }
	QRectF sceneBoundingRect() const{ return QRectF(x1, y1, ww, hh);}
	virtual QDomElement toXml(QDomDocument doc);
	virtual void paintItem(int x, int y,QPainter *pp, QPrinter *pp1, qreal scale);
	int x1,y1, ww, hh;
	QRectF br;
	Qt::Alignment align;
protected:
	QVariant itemChange(GraphicsItemChange change, const QVariant &value);
};

#endif
