

#ifndef ITABS_H
#define ITABS_H

#include <qpainter.h>
#include <QObject>
#include <QGraphicsLineItem>
#include <QGraphicsRectItem>
#include <QGraphicsEllipseItem>
#include <QtGui>
#include <QGraphicsItem>
#include "elements.h"
#include "ui_fstyletab.h"
#include "ui_postab.h"

class PositionTab : public QWidget, public Ui::postab
{
	Q_OBJECT

public:
	PositionTab(EdgeItem *item, QWidget *parent = 0);
	QSpinBox *SpinBox[4];
	EdgeItem *citem;
	int scount;
public slots:
	void changed(EdgeItem *item);
	void schanged(int i);
	void change_isize();
	
};
class LineTab : public QWidget
{
	Q_OBJECT

public:
	LineTab(EdgeItem *item, QWidget *parent = 0);
	QSpinBox *SpinBox;
	QPushButton *button, *button1;
	EdgeItem *citem;
public slots:
//	void changed(EdgeItem *item);
	void achanged(int i);
	void wchanged(int i);
	void cchanged();
	void fchanged();
	
};

class ImageTab : public QWidget
{
	Q_OBJECT

public:
	ImageTab(EdgeItem *item, QWidget *parent = 0);
	EdgeItem *citem;
	QPushButton *button, *button1;
public slots:
	void cchanged();
	
};
class TextTab : public QWidget
{
	Q_OBJECT

public:
	TextTab(EdgeItem *item, QWidget *parent = 0);
	EdgeItem *citem;
	QTextEdit *editInfo;

public slots:
	void cchanged();
	
};
class TextStyleTab : public QWidget, public Ui::fstyletab
{
	Q_OBJECT

public:
	TextStyleTab(EdgeItem *item, QWidget *parent = 0);
	EdgeItem *citem;
//	QPushButton *button,*button1;
	QAction	*actionAlignLeft,
		*actionAlignCenter,
		*actionAlignRight,
		*actionTextUnderline,
		*actionTextItalic,
		*actionTextBold;

public slots:
	void cchanged();
	void cchanged1();
	void schanged(int value);
	void col_changed(int index);
	void fchanged(const QFont & font);

	void textAlign(QAction *a);
	void textBold();
	void textItalic();
	void textUnderline();
	
};


#endif
