/****************************************************************************
**
** Copyright (C) 2007 Aleksey Luzin. All rights reserved.
**
** This file is part of the qLabels project.
**
** This file may be used under the terms of the GNU General Public
** License version 2.0 as published by the Free Software Foundation
** and appearing in the file LICENSE.GPL included in the packaging of
** this file.  Please review the following information to ensure GNU
** General Public Licensing requirements will be met:
** http://www.trolltech.com/products/qt/opensource.html
**
** If you are unsure which license is appropriate for your use, please
** review the following information:
** http://www.trolltech.com/products/qt/licensing.html or contact the
** sales department at sales@trolltech.com.
**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
****************************************************************************/

#include <qstatusbar.h>
#include <qmessagebox.h>
#include <qmenubar.h>
#include <qapplication.h>
#include <qdesktopwidget.h>
#include <qimage.h>
#include <qtimer.h>
#include <qdebug.h>

#include "canvas.h"

#include <stdlib.h>



int main(int argc, char** argv)
{
    QApplication app(argc,argv);
    QGraphicsScene canvas;
    canvas.setBackgroundBrush(Qt::lightGray);

    QString locale = QLocale::system().name();
    QStringList dirs;
#ifdef Q_WS_WIN32
    dirs << app.applicationDirPath()  + "/";
#else
    dirs << "/usr/share/qlabels/" << "/usr/local/share/qlabels/" << QDir::homePath() + "/.qlabels/" << app.applicationDirPath() + "/";
#endif


    QTranslator translator;
    for(int i=0;i<dirs.size();++i) {
        if((translator.load(QString("qlabels_") + locale, dirs.at(i)))||(translator.load(QString("qlabels_") + locale, dirs.at(i)+"i18n/"))) { 
	    qDebug() <<dirs.at(i);
    	    break;
	}
    }
    app.installTranslator(&translator);

    QStringList args = QCoreApplication::arguments ();
    Main m(canvas);
    if(args.count()>0) {
	for(int i=0;i<args.count();i++) {
	    QString arg = args.at(i);
	    if(!arg.startsWith("--")) {
		m.load_file(arg);
	    }
	}
    }
    m.show();

    QObject::connect( qApp, SIGNAL(lastWindowClosed()), qApp, SLOT(quit()) );
	
    return app.exec();
}

