/****************************************************************************
**
** Copyright (C) 2006-2006 Trolltech ASA. All rights reserved.
**
** This file is part of the example classes of the Qt Toolkit.
**
** This file may be used under the terms of the GNU General Public
** License version 2.0 as published by the Free Software Foundation
** and appearing in the file LICENSE.GPL included in the packaging of
** this file.  Please review the following information to ensure GNU
** General Public Licensing requirements will be met:
** http://www.trolltech.com/products/qt/opensource.html
**
** If you are unsure which license is appropriate for your use, please
** review the following information:
** http://www.trolltech.com/products/qt/licensing.html or contact the
** sales department at sales@trolltech.com.
**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
****************************************************************************/

#ifndef NEWLABEL_H
#define NEWLABEL_H

#include <QSystemTrayIcon>
#include <QWidget>
#include <QMessageBox>
#include <QGraphicsView>
#include <QGraphicsRectItem>
#include <QDomElement>
#include "qmainwindow.h"
#include "lib/papers.h"
#include "lib/tools.h"
#include "lib/templates.h"
#include "ui_newlabel.h"

class QAction;
class QCheckBox;
class QComboBox;
class QGroupBox;
class QLabel;
class QLineEdit;
class QMenu;
class QPushButton;
class QSpinBox;
class QTextEdit;
class QListWidget;
class QTabWidget;


class NewLabel : public QDialog, public Ui::NewLabel
{
	Q_OBJECT

public:
	NewLabel();
	void draw_template();
	QDomElement current_paper;
	QDomElement current_template;
//	QCheckBox *rotate;
protected:

private slots:
	void cchanged(int index);
	void tchanged(int index);
private:
	Templates *templates;
	Papers *papers;
/*	QComboBox *paperCombo;
	QComboBox *templateCombo;*/
	QGraphicsScene *scene;
/*	QLabel *description;
	QLabel *page_size;
	QLabel *label_size;
	QLabel *format;*/
//	QGraphicsView *view;
	QGraphicsRectItem * pr;
	QDomNodeList l1;
};

#endif
